from ox_script import *
import time
import os
from openpyxl import load_workbook
import threading

# formList = ['不干胶.txt', '洗水唛.txt', '吊牌.txt']
formList = ['dryless.txt', 'carelabel.txt', 'hangtag.txt']
excelList = ['dryless.xlsx', 'carelabel.xlsx', 'hangtag.xlsx']
#formName = '不干胶.txt'
printNum = '10'
formName = 'dryless.txt'

def choose_printNum(value):
  global printNum
  printNum = value

def backToMainPage():
  stopScan()
  PTK_UIChangePage('page_0')

def confirmFormPage():
  global formName
  if formName == formList[0]:
    PTK_UIChangePage('page_1')
  elif formName == formList[1]:
    PTK_UIChangePage('page_2')
  elif formName == formList[2]:
    uiController['page_3']['Widget_1'].update('-----')
    uiController['page_3']['Widget_2'].update('-----')
    uiController['page_3']['Widget_3'].update('-----')
    uiController['page_3']['Widget_4'].update('-----')
    PTK_UIChangePage('page_3')
    startScan()
  else:
    return
  
def choose_form(value):
  global formName
  formName = formList[int(value)]
  
def choose_size(value):
  global size
  size = drylessSizeList[int(value)]
  
def choose_color(value):
  global color
  color = drylessColorList[int(value)]

def onPrintDone(excelName,data):
  if not os.path.exists(excelName) or not data:
    return 
  workbook = load_workbook(excelName)
  sheet = workbook.active
  next_row = sheet.max_row + 1
  for row_item in data:
    for col_num, value in enumerate(row_item, start=1):
      sheet.cell(row=next_row, column=col_num, value=value)
    next_row += 1
  workbook.save(excelName)

#define dryless form variables
drylessModelNum = 'C5CK127X7672'
drylessProductName = 'EX女圆领宽版短袖T恤'
drylessColorList = ['黑', '白', '红', '浅绿', '蓝']
drylessSizeList = ['M', 'L', 'XL', '2XL', '3XL']
drylessStartCode = '8112311802810003080'
# drylessStartCode = '1231180281'
#drylessPrintNum = '10'

drylessColor='黑'
drylessSize='M'

def ondrylessModelNumChange(value):
  global drylessModelNum
  drylessModelNum = value

def ondrylessProductNameChange(value):
  global drylessProductName
  drylessProductName = value

def choose_drylessColor(value):
  global drylessColor
  drylessColor = drylessColorList[int(value)]

def choose_drylessSize(value):
  global drylessSize
  drylessSize = drylessSizeList[int(value)]

def choose_drylessStartCode(value):
  global drylessStartCode
  drylessStartCode = value
  
def dryLessPrint():
  global formName
  global drylessModelNum
  global drylessProductName
  global drylessStartCode
  global drylessColor
  global drylessSize
  global printNum
  cmd = PTK_UpdateAllFormVariables(
            formName,
            Input1=drylessModelNum,
            Input2=drylessProductName,
            Input3=drylessColor,
            Input4=drylessSize,
            Input5=printNum,
            Input6=drylessStartCode,
        )
  PTK_SendCmdToPrinter(cmd)
  time.sleep(2)
  updatedStartCode = int(drylessStartCode)  + int(printNum)
  uiController['page_1']['Widget_5'].update(str(updatedStartCode))
  data = []
  date = time.strftime("%Y/%m/%d %C:%m", time.localtime())
  for i in range(int(printNum)):
    drylessStartCode = str(int(drylessStartCode) + 1)
    printItem= [drylessStartCode,drylessProductName,drylessColor,drylessSize,date]
    data.append(printItem)
  onPrintDone(excelName=excelList[0],data = data)

#define carelabel form variables
carelabelModelNum = 'C5CK127X7672'
carelabelProductName = 'EX女圆领宽版短袖T恤'
carelabelColorList = ['黑', '白', '红', '浅绿', '蓝']
carelabelSizeList = ['M', 'L', 'XL', '2XL', '3XL']
carelabelProductCode = '6900000000007'
#carelabelPrintNum = '10'

carelabelColor='黑'
carelabelSize='M'

def oncarelabelModelNumChange(value):
  global carelabelModelNum
  carelabelModelNum = value

def oncarelabelProductNameChange(value):
  global carelabelProductName
  carelabelProductName = value

def choose_carelabelColor(value):
  global carelabelColor
  carelabelColor = carelabelColorList[int(value)]

def choose_carelabelSize(value):
  global carelabelSize
  carelabelSize = carelabelSizeList[int(value)]

def choose_carelabelProductCode(value):
  global carelabelProductCode
  carelabelProductCode = value

def carelabelPrint():
  global formName
  global carelabelModelNum
  global carelabelProductName
  global carelabelProductCode
  global carelabelColor
  global carelabelSize
  global printNum
  cmd = PTK_UpdateAllFormVariables(
            formName,
            Input1=carelabelModelNum,
            Input2=carelabelProductName,
            Input3=carelabelColor,
            Input4=carelabelSize,
            Input5=printNum,
            Input6=carelabelProductCode,
        )
  PTK_SendCmdToPrinter(cmd)
  time.sleep(2)
  data = []
  date = time.strftime("%Y/%m/%d %C:%m", time.localtime())
  printItem= [carelabelModelNum,carelabelProductName,carelabelColor,carelabelSize,carelabelProductCode,printNum,date]
  data.append(printItem)
  onPrintDone(excelName=excelList[1],data = data)
  


#define hangtag form variables
hangtagModelNum = '-----'
hangtagProductName = '-----'
hangtagColor = '-----'
hangtagSize = '-----'


scanFile = 'scan.xlsx'
isScanning = True
scanData = []


def scan():
  global isScanning
  global scanData
  global hangtagModelNum
  global hangtagProductName
  global hangtagColor
  global hangtagSize
  while isScanning:
    data = PTK_GetPortData(PORT_USBHOST, timeout=100)
    if data != -1:
        if scanData.__len__() == 0:
          continue
        for item in scanData:
          if item[0][2:12] == data:
            hangtagModelNum = item[1]
            hangtagProductName = item[2]
            hangtagColor = item[4]
            hangtagSize = item[6]
            cmd = PTK_UpdateAllFormVariables(
                formName,
                Input1=item[0][2:12],
                Input2=item[1],
                Input3=item[2],
                Input4=item[3],
                Input5=item[4],
                Input6=item[5],
                Input8=item[6],
            )
            PTK_SendCmdToPrinter(cmd)
            uiController['page_3']['Widget_1'].update(str(hangtagModelNum))
            uiController['page_3']['Widget_2'].update(str(hangtagProductName))
            uiController['page_3']['Widget_3'].update(str(hangtagColor))
            uiController['page_3']['Widget_4'].update(str(hangtagSize))
    time.sleep(1)

def startScan():
  global isScanning
  isScanning = True
  scan_thread = threading.Thread(target=scan)
  scan_thread.start()

def stopScan():
  global isScanning
  isScanning = False

def retriveScanData():
  global scanData
  global scanFile
  scan_workbook = load_workbook(scanFile)
  sheet = scan_workbook.active
  for row in sheet.iter_rows(min_row=2, max_row=sheet.max_row, min_col=1, max_col=sheet.max_column, values_only=True):
    scanData.append(row)

if __name__ == "__main__":
  retriveScanData()
  page_0 = PTK_UIPage(
    list1 := PTK_UIList(
      title = "选择模板",
      items = formList,
      value = '0',
      Onpressed = choose_form,
    ),
    PTK_UIButton(title="确认", Onpressed=confirmFormPage),
  )
  
  #-------------pageDryless----------------
  page_1 = PTK_UIPage(
    PTK_UIInput(title="款号",value=drylessModelNum, Onsubmit=ondrylessModelNumChange, Onchange=ondrylessModelNumChange),
    PTK_UIInput(title="品名",value=drylessProductName, Onsubmit=ondrylessProductNameChange),
    PTK_UIList(
      title = "选择颜色",
      items = drylessColorList,
      Onpressed = choose_drylessColor,
    ),
    PTK_UIList(
      title = "选择尺寸",
      items = drylessSizeList,
      Onpressed = choose_drylessSize,
    ),
    PTK_UIInput(title="起始条码",value=drylessStartCode,Onsubmit=choose_drylessStartCode),
    PTK_UIInput(title="打印数量",value=printNum,Onsubmit=choose_printNum),
    PTK_UIButton(title="打印",Onpressed=dryLessPrint),
    PTK_UIButton(title="返回", Onpressed=backToMainPage),
  )
  #-------------pageCarelabel----------------
  page_2 = PTK_UIPage(
    PTK_UIInput(title="款号",value=carelabelModelNum,Onsubmit=oncarelabelModelNumChange),
    PTK_UIInput(title="品名",value=carelabelProductName,Onsubmit=oncarelabelProductNameChange),
    PTK_UIList(
      title = "选择颜色",
      items = carelabelColorList,
      Onpressed = choose_carelabelColor,
    ),
    PTK_UIList(
      title = "选择尺寸",
      items = carelabelSizeList,
      Onpressed = choose_carelabelSize,
    ),
    PTK_UIInput(title="商品条码",value=carelabelProductCode, Onsubmit=choose_carelabelProductCode),
    PTK_UIInput(title="打印数量",value=printNum,Onsubmit=choose_printNum),
    PTK_UIButton(title="打印",Onpressed=carelabelPrint),
    PTK_UIButton(title="返回", Onpressed=backToMainPage),
  )
  #-------------pageHangtag----------------
  page_3 = PTK_UIPage(
    PTK_UITextBox(title="款号",value=hangtagModelNum),
    PTK_UITextBox(title="品名",value=hangtagProductName),
    PTK_UITextBox(title="颜色",value=hangtagColor),
    PTK_UITextBox(title="尺码",value=hangtagSize),
    PTK_UIButton(title="返回", Onpressed=backToMainPage),
  )

  uiController = PTK_UIInit(
    page_0,
	page_1,
    page_2,
    page_3,
	require_execute_confirmation = False,	
    )

